100 REMark *********************************************************************************
110 REMark Program Name:   FilterINTER_bas
120 REMark Purpose:        Translates USENET/INTERNET format to Compuserve message
130 REMark                   format for use with QL BBS Message Reader
140 REMark Author:         James Hunkins     Copyright 1994/1995
150 REMark                                   JDH Technologies
160 REMark                                   Freeware
170 REMark Input:          (program prompts)
180 REMark                 Name of text file containing USENET/INTERNET messages
190 REMark                 Name of output file for translating messages
200 REMark                 Output Format options, -Tn, -Fn
210 REMark Output:         Message file matching Compuserve format for QL BBS
220 REMark                   Message Reader
230 REMark Document:       FilterINTER_txt
240 REMark Update Info:    09-10-94  V0.00  original _c version
250 REMark                 09-18-94  Vb0.00 original _bas version
260 REMark                   - can be compiled with QLiberator
270 REMark                 01-25-95  Vb0.10 Modified to allow out-of-order header lines
280 REMark                   - changed to skip message errors to missing info
290 REMark                     warnings, added for more header lines
300 REMark                     . line count missing still skips message
301 REMark                   - now removed CHR$(13) from end of lines
310 REMark Special Notes:  . message numbers used (Message-ID) are alphanumeric
320 REMark                   - QL Message reader expects numeric only
330 REMark                   - assigns numeric numbers automatically and stores
340 REMark                     translation in 'OutputFileName_mnt'
350 REMark                   - used_mssg_no=5_chars_left_justify 5_spaces actual_message_no
360 REMark                 . FROM line can be long and complex so different forms available
370 REMark                     from_style => default = 0
380 REMark                       0 = full       jodyc#main1.main2.gen1.gen2 (Jody S. Anyone)
390 REMark                       1 = short      jodyc
400 REMark                       2 = address    jodyc#main1.main2.gen1.gen2
410 REMark                       3 = real name                             Jody S. Anyone
420 REMark                 . normal TO line not available, so options for alternatives
430 REMark                     to_style => default = 0
440 REMark                       0 = Followup-To line
450 REMark                       1 = Organization line
460 REMark                 . starts reading header at start of file or after rading mssg
470 REMark                     header lines start with keyword;
480 REMark                     header ends with blank line
490 REMark
500 REMark Progress Notes:
510 REMark   debugging rewrite - no messages found
511 REMark   window handling if called as EX versus LOAD and RUN
520 REMark
530 REMark
540 REMark *********************************************************************************
550 REMark *** setup constant variables ***
560 REMark   the following strings are what key lines start with
570 REMark     the _len term is the number of characters
580 section_line$     = "Newsgroups:"    : REMark SECTION name
590 section_line_len  = 11
600 new_mssg$         = "Path:"          : REMark START of a new message
610 new_mssg_len      = 5
620 mssg_id$          = "Message-ID:"    : REMark message number
630 mssg_id_len       = 11
640 follow_line$      = "Followup-To:"   : REMark Followup-To line
650 follow_line_len   = 12
660 subj_line$        = "Subject:"       : REMark SUBJECT name
670 subj_line_len     = 8
680 org_line$         = "Organization:"  : REMark Organization line
690 org_line_len      = 13
700 from_line$        = "From:"          : REMark FROM name
710 from_line_len     = 5
720 date_line$        = "Date:"          : REMark DATE
730 date_line_len     = 5
740 mssg_len$         = "Lines:"         : REMark number of lines in message
750 EOL               = 10               : REMark end of line character
760 sect_limit        = 128              : REMark maximum number of section names
770 false             = 0
780 true              = 1
790 REMark ***********************************************************************
800 REMark Main Program
810 :
820   REMark initialize and open files
830   init
840   res_window
850   REMark get input file name
860   INPUT#win1;"Enter file containing messages: "; input_name$
870   IF (input_name$ = "") THEN error_out 1,2,input_name$
880   in = FOP_IN(input_name$)
890   IF (in < 0) THEN error_out 1,2,input_name$
900   REMark get output file name
910   PRINT#win1;"Enter destination file name [";input_name$;"_mrd] : ";
920   INPUT#win1; output_name$
930   IF (output_name$ = "") THEN output_name$ = input_name$ & "_mrd"
940   out = FOP_OVER(output_name$)
950   IF (out < 0) THEN error_out 1,3,output_name$
960   REMark get from format options
970   res_window
980   PRINT#win1\\"     =============================================================== "
990   PRINT#win1; "    | FROM styles:                                                  |"
1000   PRINT#win1; "    |   0 = full       jodyc@main1.main2.gen1.gen2 (Jody S. Anyone) |"
1010   PRINT#win1; "    |   1 = short      jodyc                                        |"
1020   PRINT#win1; "    |   2 = address    jodyc@main1.main2.gen1.gen2                  |"
1030   PRINT#win1; "    |   3 = real name  Jody S. Anyone                               |"
1040   PRINT#win1; "    |_______________________________________________________________|"
1050   AT #win1,12,1: PRINT#win1;"Enter FROM line format [0 to 3, default = 0] ";
1060   REPeat from1
1070     AT #win1,12,48: temp$ = INKEY$(#win1,-1)
1080     IF (CODE(temp$) = 10) THEN temp$ = "0"
1090     PRINT#win1;temp$;: PAUSE(10)
1100     IF ((temp$ >= "0") AND (temp$ <= "3")) THEN EXIT from1
1110     PRINT#win1\\"Error in input, must be between 0 and 3..."\"  Try again"
1120   END REPeat from1
1130   from_style = temp$
1140   res_window
1150   PRINT#win1\\"     ========================= "
1160   PRINT#win1; "    | TO line source:         |"
1170   PRINT#win1; "    |   0 = Followup-To line  |"
1180   PRINT#win1; "    |   1 = Organization line |"
1190   PRINT#win1; "    |_________________________|"
1200   AT #win1,9,1: PRINT#win1;"Enter TO line source [0 to 1, default = 0] ";
1210   REPeat to1
1220     AT #win1,9,46: temp$ = INKEY$(#win1,-1)
1230     IF (CODE(temp$) = 10) THEN temp$ = "0"
1240     PRINT#win1;temp$: PAUSE(10)
1250     IF ((temp$ = "0") OR (temp$ = "1")) THEN EXIT to1
1260     PRINT#win1\"Error in input, must be between 0 and 1..."\"  Try again"
1270   END REPeat to1
1280   to_style = temp$
1290   CLS#win1
1300   res_window
1310   REMark open message number translation file, output header line
1320   output_name$ = output_name$ & "_mnt": REMark add _mnt to file output name
1330   trans = FOP_OVER(output_name$)
1340   IF (trans < 0) THEN error_out 1,3,output_name$
1350   PRINT#trans;"Message Number Translations: ";output_name$
1360   PRINT#trans;"======================================================="
1370   PRINT#trans;"Used No   Original No"
1380   REMark translate file
1390   result = translate
1400   IF (result = 0) THEN
1410     PRINT#win1;"No messages found"
1420     DELETE "file_name": REMark delete output file
1430   END IF
1440   error_out 1,0,CHR$(10) & " > Program Closed < "
1450   CLOSE
1460   STOP
1470 :
1480 :
1490 :
1500 REMark *********************************************************************
1510 REMark Procedure: init
1520 REMark Purpose:   initialise variables
1530 :
1540 DEFine PROCedure init
1550   REMark define default variables
1560   from_style = 0
1570     REMark   0 = full     jodyc#main1.main2.gen1.gen2 (Jody S. Anyone)
1580     REMark   1 = short    jodyc
1590     REMark   2 = address  jodyc#main1.main2.gen1.gen2
1600     REMark   3 = real name                             Jody S. Anyone
1610   to_style = 0
1620     REMark   0 = Followup-To line
1630     REMark   1 = Organization line
1640   DIM section$(sect_limit,40)
1650   REMark setup program window
1660   win1 = FOPEN("CON_464x170a26x40")
1670   PAPER#win1,0: INK#win1,7: BORDER#win1,4,1
1680 END DEFine init
1690 :
1700 :
1710 REMark *********************************************************************
1720 REMark Procedure: res_window
1730 REMark Purpose:   clears window and outputs title bar
1740 :
1750 DEFine PROCedure res_window
1760   CLS#win1
1770   INK#win1,2
1780   PRINT#win1;"(c)1994 JD Hunkins     INTERNET/USENET Filter     JDH Technologies  Vb0.10"\\
1790   LINE#win1,0,94 TO 214,94
1800   INK#win1,7
1810 END DEFine res_window
1820 :
1830 :
1840 REMark *********************************************************************
1850 REMark Function:  translate
1860 REMark Purpose:   reads, translates from INTERNET/USENET format to native
1870 REMark              format (CIS) for QL BBS Message reader
1880 REMark Return:    number of messages translated
1890 :
1900 DEFine FuNction translate
1910 LOCal section_ptr, done, mssg_done, mssg_output, found
1920 section_ptr = 0: REMark next entry in section array
1930 done = 0:        REMark 0 = indicates not done
1940 mssg_done = 0:   REMark 0 = indicates not done
1950 mssg_output = 0: REMark 0 = no messages output to output file
1960 found = 0:       REMark 1 = item found
1970 mssg_count = 0:  REMark message being translated
1980 line_ctr = 0:    REMark line read from input file
1990
2000   REMark read in messages and translate header/end format to native format (CIS)
2010   AT #win1;5,0: PRINT#win1;"TRANSLATING MSSG #: 1": REMark message # and back space
2020   :
2030   REPeat mssg_found
2040     REMark loop until message found or end of file
2050     IF ((done <> 0) OR (EOF(#in))) THEN EXIT mssg_found
2060     :
2070     REMark initialize next message header info
2080     too$ = "": datee$ = "": mssg_no$ = "": subj$ = ""
2090     from$ = "": section_name$ = ""
2100
2110     REMark find start of message
2120
2130     REMark check for first line with key word and process
2140     REMark   first check for ':' in first 13 characters
2150     REMark     - then first character in word
2160     REMark     - then actual word and handle
2165     header_found = false: REM prepare to start looking for new header
2170     REPeat header_start1
2180       REM jump position, start of header_start1
2190       IF (header_found = true) THEN EXIT header_start1
2200       IF (EOF(#in)) THEN EXIT mssg_found
2210
2220       INPUT#in;line$: REMark read in next line
2225       proc_strip
2230       line_ctr = line_ctr + 1: REMark increment line counter
2240
2250       REMark check to see if line starts with NEW_MSSG key word(s)
2260       colon_pos = ":" INSTR line$
2270       IF ((colon_pos = false) OR (colon_pos > 13)) THEN GOTO 2180
2280
2290       letter = code(line$(1 TO 1))
2300       IF letter >= 97 THEN letter = letter - 32: REM make upper case
2310       SELect ON letter
2320         ON letter = 80 : REM P - Path:
2330           IF (new_mssg$ INSTR line$ = true)
2340             header_found = true
2350             process_path
2360           END IF
2370         ON letter = 70 : REM F - From: or Followup-To:
2380           IF (from_line$ INSTR line$ = true)
2390             header_found = true
2400             process_from
2410           ELSE
2420             IF (follow_line$ INSTR line$ = true)
2430               header_found = true
2440               process_follow
2450             END IF
2455           END IF
2460         ON letter = 78 : REM N - Newsgroups:
2470           IF (section_line$ INSTR line$ = true)
2480             header_found = true
2490             process_section
2500           END IF
2510         ON letter = 83 : REM S - Subjects:
2520           IF (subj_line$ INSTR line$ = true)
2530             header_found = true
2540             process_subject
2550           END IF
2560         ON letter = 68 : REM D - Date:
2570           IF (date_line$ INSTR line$ = true)
2580             header_found = true
2590             process_date
2600           END IF
2610         ON letter = 79 : REM O - Organization:
2620           IF (org_line$ INSTR line$ = true)
2630             header_found = true
2640             process_org
2650           END IF
2660         ON letter = 76 : REM L - Lines:
2670           IF (mssg_len$ INSTR line$ = true)
2680             header_found = true
2690             process_length
2700           END IF
2710         ON letter = 77 : REM M - Message-ID:
2720           IF (mssg_id$ INSTR line$ = true)
2730             header_found = true
2740             process_id
2750           END IF
2760       END SELECT
2761       REM only the above cases can be keywords, skip rest
2770     END REPeat header_start1
2780
2790     IF (header_found = false) THEN  : REM header not found, exit translate
2800       done = 1
2810       EXIT mssg_found
2820     END IF
2830     REM header_found = false  : REM prepare for next header search
2840
2850
2860     REM header has been started, scan rest of header until blank line
2870     REPeat rest_of_header
2880       REM jump position, start of rest_of_header
2890       IF (EOF(#in)) THEN EXIT rest_of_header : REM end of file, quit translate
2900
2910       INPUT#in;line$: REMark read in next line
2915       proc_strip
2920       line_ctr = line_ctr + 1: REMark increment line counter
2930
2940       REM check for blank line (end of header)
2950       IF (line$ = "") THEN EXIT rest_of_header
2960
2970       REMark check to see if line starts with NEW_MSSG key word(s)
2980       colon_pos = ":" INSTR line$
2990       IF ((colon_pos = false) OR (colon_pos > 13)) THEN GOTO 2880
3000
3010       letter = code(line$(1 TO 1))
3020       IF letter >= 97 THEN letter = letter - 32: REM make upper case
3030       SELect ON letter
3040         ON letter = 80 : REM P - Path:
3050           IF (new_mssg$ INSTR line$ = true)
3060             header_found = true
3070             process_path
3080           END IF
3090         ON letter = 70 : REM F - From: or Followup-To:
3100           IF (from_line$ INSTR line$ = true)
3110             header_found = true
3120             process_from
3130           ELSE
3140             IF (follow_line$ INSTR line$ = true)
3150               header_found = true
3160               process_follow
3165             END IF
3170           END IF
3180         ON letter = 78 : REM N - Newsgroups:
3190           IF (section_line$ INSTR line$ = true)
3200             header_found = true
3210             process_section
3220           END IF
3230         ON letter = 83 : REM S - Subjects:
3240           IF (subj_line$ INSTR line$ = true)
3250             header_found = true
3260             process_subject
3270           END IF
3280         ON letter = 68 : REM D - Date:
3290           IF (date_line$ INSTR line$ = true)
3300             header_found = true
3310             process_date
3320           END IF
3330         ON letter = 79 : REM O - Organization:
3340           IF (org_line$ INSTR line$ = true)
3350             header_found = true
3360             process_org
3370           END IF
3380         ON letter = 76 : REM L - Lines:
3390           IF (mssg_len$ INSTR line$ = true)
3400             header_found = true
3410             process_length
3420           END IF
3430         ON letter = 77 : REM M - Message-ID:
3440           IF (mssg_id$ INSTR line$ = true)
3450             header_found = true
3460             process_id
3470           END IF
3480       END SELECT : REM letter, the above cases can be keywords, skip rest
3490     END REPeat rest_of_header
3500
3510     IF (EOF(#in)) THEN
3520       done = 1
3530       REM EXIT rest_of_header
3540     END IF
3550
3560     mssg_count = mssg_count + 1: REMark message found, so increment count
3570     AT #win1;5,20: PRINT#win1;mssg_count;
3580
3590     REMark output to header to output file in native format
3600
3610     REMark check for sufficient header information
3620     header_error = false
3640     IF (mssg_no$ = "") THEN
3650       mssg_no$ = "999"
3660       error_out 0, -7, mssg_no$
3670     END IF
3680
3690     IF (from$ = "") THEN
3700       error_out 0, -1, mssg_no$
3710       from$ = "Unknown"
3720     END IF
3730
3740     IF (too$ = "") THEN
3750       error_out 0, -2, mssg_no$
3760       too$ = "Unknown"
3770     END IF
3780
3790     IF (subj$ = "") THEN
3800       error_out 0, -3, mssg_no$
3810       subj$ = "Unknown"
3820     END IF
3830
3840     IF (section_name$ = "") THEN
3850       error_out 0, -4, mssg_no$
3860       section_number$ = "999"
3870       section_name$ = "Unknown"
3880     END IF
3890
3900     IF (datee$ = "") THEN
3910       error_out 0, -8, mssg_no$
3920       datee$ = "xx-xxx-xxxx"
3930     END IF
3940
3950     IF (line_ct = -1) THEN
3960       error_out 0, -6, mssg_no$
3970       header_error = true
3980     END IF
3990
4000
4010     IF (header_error = false) THEN
4020       PRINT#out;"#: ";mssg_no$;" ";section_number$;"/";section_name$
4030       PRINT#out;"    "; datee$
4040       PRINT#out;"Sb: "; subj$
4050       PRINT#out;"Fm: "; from$
4060       PRINT#out;"To: "; too$
4070     END IF
4080
4090
4100     REMark output message lines
4110     IF (header_error = true)  : REM skip message
4120       FOR i=0 to line_ct - 1
4130         INPUT#in, line$: line_ctr = line_ctr + 1
4135         proc_strip
4140       END FOR i
4150     ELSE                      : REM output message
4160       FOR i=0 TO line_ct - 1
4170         INPUT#in, line$: line_ctr = line_ctr + 1
4175         proc_strip
4180         PRINT#out, line$
4190       END FOR i
4200     END IF
4210
4220   END REPeat mssg_found
4230
4240 RETurn mssg_count
4250 END DEFine translate
4290 :
4300 :
4310 REMark *********************************************************************
4320 REMark Function:  process_path
4330 REMark Purpose:   parses Path: line
4340 REMark Input:     none
4350 REMark Global:    line$ - line to be parsed
4360 REMark Output:    none
4370 REMark
4380 :
4390 DEFine PROCedure process_path
4400   path$ = line$(new_mssg_len + 2 TO )
4410 END DEFine process_path
4420 :
4430 :
4440 REMark *********************************************************************
4450 REMark Function:  process_from
4460 REMark Purpose:   parses From: line
4470 REMark Input:     none
4480 REMark Global:    line$ - line to be parsed
4490 REMark Output:    none
4500 REMark
4510 :
4520 DEFine PROCedure process_from
4530   SELect ON from_style
4540     ON from_style = 0
4550       REMark full line
4560       from$ = line$(from_line_len + 2 TO )
4570     ON from_style = 1
4580       REMark short form
4590       temp1 = '@' INSTR line$
4600       IF (LEN(line$) >= (from_line_len + 2)) THEN
4610         from$ = line$(from_line_len + 2 TO temp1 - 1)
4620       ELSE
4630         from$ = ""
4640       END IF
4650     ON from_style = 2
4660       REMark address form
4670       temp1 = '(' INSTR line$
4680       IF (LEN(line$) >= (from_line_len + 2)) THEN
4690         IF (temp1 = 0) THEN
4700           from$ = line$(from_line_len + 2 TO )
4710         ELSE
4720           IF (LEN(line$) >= (temp1 - 0)) THEN from$ = line$(from_line_len + 2 TO temp1 - 1)
4730         END IF
4740       END IF
4750     ON from_style = 3
4760       REMark real name
4770       temp1 = '(' INSTR line$
4780       IF ((temp1 <> 0) AND (LEN(from$) < (temp1 + 1))) THEN
4790         from$ = line$(temp1 + 1 TO )
4800         temp1 = ')' INSTR from$
4810         IF (temp1 <> 0) THEN from$ = from$(TO temp1 - 1)
4820       END IF
4830   END SELect
4840 END DEFine process_from
4850 :
4860 :
4870 REMark *********************************************************************
4880 REMark Function:  process_section
4890 REMark Purpose:   parses Newsgroups: line
4900 REMark Input:     none
4910 REMark Global:    line$ - line to be parsed
4920 REMark Output:    none
4930 REMark
4940 :
4950 DEFine PROCedure process_section
4960   section_name$ = line$(section_line_len + 2 TO)
4970
4980   REMark check for section name previously existing, if not store new one
4990   REMark first section name entry
5000   IF (section_ptr = 0) THEN
5010     section$(section_ptr) = section_name$
5020     section_number$ = "0"
5030     section_ptr = section_ptr + 1
5040   ELSE
5050     REMark section_number$ = "" indicates no match found
5060     section_number$ = ""
5070     FOR i = 0 TO section_ptr - 1
5080       IF (section_name$ = section$(i)) THEN
5090         REMark section previously used
5100         section_number$ = i
5110         EXIT i
5120       END IF
5130     END FOR i
5140     IF (section_number$ = "") THEN
5150       REMark no previous use of section name
5160       IF (section_ptr >= sect_limit) THEN
5170         error_out 0, -4, mssg_count: REMark too many section names, overflow
5180         section_number$ = "999"
5190         section_name$ = "OVERFLOW"
5200       ELSE
5210         REMark new section name, add and use
5220         section_number$ = section_ptr
5230         section$(section_ptr) = section_name$
5240         section_ptr = section_ptr + 1
5250       END IF
5260     END IF
5270   END IF
5280 END DEFine process_section
5290 :
5300 :
5310 REMark *********************************************************************
5320 REMark Function:  process_subject
5330 REMark Purpose:   parses Subjects: line
5340 REMark Input:     none
5350 REMark Global:    line$ - line to be parsed
5360 REMark Output:    none
5370 REMark
5380 :
5390 DEFine PROCedure process_subject
5400   subj$ = line$(subj_line_len + 2 TO )
5410 END DEFine process_subject
5420 :
5430 :
5440 REMark *********************************************************************
5450 REMark Function:  process_follow
5460 REMark Purpose:   parses FollowUp-To: line
5470 REMark Input:     none
5480 REMark Global:    line$ - line to be parsed
5490 REMark Output:    none
5500 REMark
5510 :
5520 DEFine PROCedure process_follow
5530   IF (to_style = 0) THEN too$ = line$(follow_line_len + 2 TO )
5540 END DEFine process_follow
5550 :
5560 :
5570 REMark *********************************************************************
5580 REMark Function:  process_date
5590 REMark Purpose:   parses Date: line
5600 REMark Input:     none
5610 REMark Global:    line$ - line to be parsed
5620 REMark Output:    none
5630 REMark
5640 :
5650 DEFine PROCedure process_date
5660   string1$ = ""
5670   string2$ = ""
5680   temp1 = ',' INSTR line$
5690   REMark if <> 0, includes day, skip day
5700   IF (temp1 = 0) THEN
5710     IF (LEN(line$) >= date_line_len+2) THEN
5720       line$ = line$(date_line_len+2 TO )
5730     ELSE
5740       line$ = ""
5750     END IF
5760   ELSE
5770     IF (LEN(line$) >= temp1+2) THEN
5780       line$ = line$(temp1+2 TO )
5790     ELSE
5800       line$ = ""
5810     END IF
5820   END IF
5830   temp1 = ' ' INSTR line$
5840   datee$ = line$
5850   IF (LEN(line$) > (temp1 - 1)) THEN  datee$ = line$(TO temp1 - 1)
5860   IF (LEN(line$) >= (temp1 + 1)) THEN
5870     line$ = line$(temp1 + 1 TO )
5880   ELSE
5890     line$ = ""
5900   END IF
5910   temp1 = ' ' INSTR line$
5920   IF (temp1 > 1) THEN string1$ = line$(TO temp1 - 1)
5930   IF (LEN(line$) >= (temp1 + 1)) THEN
5940     line$ = line$(temp1 + 1 TO )
5950   ELSE
5960     line$ = ""
5970   END IF
5980   temp1 = ' ' INSTR line$
5990   IF (temp1 = 1) THEN
6000     string2$ = line$
6010   ELSE
6020     IF (temp1 > 1) THEN string2$ = line$(TO temp1 - 1)
6030   END IF
6040   datee$ = datee$ & '-' & string1$ & '-' & string2$: REMark add separators and merge date strings
6050 END DEFine process_date
6060 :
6070 :
6080 REMark *********************************************************************
6090 REMark Function:  process_org
6100 REMark Purpose:   parses Organization: line
6110 REMark Input:     none
6120 REMark Global:    line$ - line to be parsed
6130 REMark Output:    none
6140 REMark
6150 :
6160 DEFine PROCedure process_org
6170   IF (to_style = 1) THEN too$ = line$(org_line_len + 2 TO )
6180 END DEFine process_org
6190 :
6200 :
6210 REMark *********************************************************************
6220 REMark Function:  process_length
6230 REMark Purpose:   parses Lines: line
6240 REMark Input:     none
6250 REMark Global:    line$ - line to be parsed
6260 REMark Output:    none
6270 REMark
6280 :
6290 DEFine PROCedure process_length
6300   temp1 = ' ' INSTR line$
6310   string1$ = ""
6320   IF (LEN(line$) >= (temp1 - 1)) THEN string1$ = line$(TO temp1 - 1)
6330   IF (LEN(line$) >= (temp1 + 1)) THEN line_ct = line$(temp1 + 1 TO ): REMark translation to integer automatic
6340 END DEFine process_length
6350 :
6360 :
6370 REMark *********************************************************************
6380 REMark Function:  process_id
6390 REMark Purpose:   parses Message-ID: line
6400 REMark Input:     none
6410 REMark Global:    line$ - line to be parsed
6420 REMark Output:    none
6430 REMark
6440 :
6450 DEFine PROCedure process_id
6460   REMark use mssg_count for mssg number, store actual mssg_no
6470   IF (LEN(line$) >= (mssg_id_len + 2)) THEN mssg_no$ = line$(mssg_id_len + 2 TO )
6480   PRINT#trans;mssg_count;TO 10;mssg_no$
6490   mssg_no$ = mssg_count
6500 END DEFine process_id
6501 :
6502 :
6503 REMark *********************************************************************
6504 REMark Function:  proc_strip
6505 REMark Purpose:   removes non-dos code 13 EOL characters from string
6506 REMark Input:     none
6507 REMark Global:    line$
6508 REMark Output:    none (modifies line$)
6609 DEFine PROCedure proc_strip
6610 LOCal ii
6612   ii = CHR$(13) INSTR line$
6613   IF (ii = len(line$)) THEN
6614     line$ = line$( TO ii-1)
6615   ELSE
6616    IF (ii <> 0) THEN line$ = line$( TO ii-1) & line$(ii+1 TO): REM ii < len(line$)
6617   END IF
6619 END DEFine proc_strip
6620 :
6530 REMark *********************************************************************
6540 REMark Function:  error_out
6550 REMark Purpose:   outputs error messages
6560 REMark Input:       finish < 0, return as normal, -(#) = current mssg
6570 REMark                     = 1, exit(1) from program
6580 REMark              err_num = 0, quiet exit from program
6590 REMark                     > 0, ERROR message
6600 REMark                     < 0, WARNING message
6610 :
6620 DEFine PROCedure error_out(finish, err_num, other$)
6630   SELect ON err_num
6640     ON err_num = 0
6650       PRINT#win1;other$
6660     ON err_num = 2
6670       PRINT#win1\\"ERROR: could not open input file [";other$;"]..."
6680     ON err_num = 3
6690       PRINT#win1\\"ERROR: could not open output file [";other$;"]..."
6700     ON err_num = 4
6710       PRINT#win1\\"ERROR: unexpected End of File before message complete..."
6720       PRINT#win1;"   Skipping message [";other$;"]  Line #";line_ctr
6730     ON err_num = 5
6740       PRINT#win1\\"ERROR: illegal command line parameter [";other$;"]..."
6750     ON err_num = -1
6760       PRINT#win1\\"WARNING: FROM line in header is wrong/missing..."
6770       PRINT#win1;"   Message [";other$;"]  About line #";line_ctr
6780       key_pause(0)
6790     ON err_num = -2
6800       PRINT#win1\\"WARNING: TO line in header is wrong/missing"
6810       PRINT#win1;"   Message [";other$;"]  About line #";line_ctr
6820       key_pause(0)
6830     ON err_num = -3
6840       PRINT#win1\\"WARNING: SUBJECT line in header is wrong/missing..."
6850       PRINT#win1;"   Message [";other$;"]  About line #";line_ctr
6860       key_pause(0)
6870     ON err_num = -4
6880       PRINT#win1\\"WARNING: NEWSGROUP line in header is wrong/missing..."
6890       PRINT#win1;"   Message [";other$;"]  About line #";line_ctr
6900       key_pause(0)
6910     ON err_num = -5
6920       PRINT#win1\\"WARNING: Too many section names..."
6930       PRINT#win1;"  All messages after this will be section #999, 'OVERFLOW'"
6940       PRINT#win1;"    starting with message [";other$;"]  Line #"; line_ctr
6950       key_pause(0)
6960     ON err_num = -6
6970       PRINT#win1\\"WARNING: Line count not found..."
6980       PRINT#win1;"   Skipping message ["; other$; "]   About line #"; line_ctr
6990       key_pause(0)
7000     ON err_num = -7
7010       PRINT#win1\\"Message-ID not found..."
7020       PRINT#win1;"   Message [";other$;"]  About line #"; line_ctr
7030       key_pause(0)
7040     ON err_num = -8
7050       PRINT#win1\\"WARNING: Date not found..."
7060       PRINT#win1;"   Message [";other$;"]  About line #";line_ctr
7070       key_pause(0)
7080     ON err_num = REMAINER
7090       PRINT#win1\\"ERROR/WARNING: unknown error [line #";line_ctr;"]..."
7100       key_pause(0);
7110   END SELect
7120   IF (finish > 0) THEN
7130     IF (err_num <> 0) THEN PRINT#win1;"  >> Program Terminated << "\\
7140     PAUSE 100
7150     CLOSE
7160     STOP
7170   END IF
7172   AT#win1;6,0
7173   PRINT#win1;"                                                             "
7174   PRINT#win1;"                                                             "
7175   PRINT#win1;"                                                             "
7180 END DEFine error_out
7190 :
7200 :
7210 REMark *********************************************************************
7220 REMark Function:  key_pause
7230 REMark Purpose:   waits for key input
7240 REMark Input:     sound1 = 1 -> beep, 0 -> no beep
7250 :
7260 DEFine PROCedure key_pause(sound1)
7270 LOCal z$
7280   IF (sound1 = 1) THEN BEEP 2400,10000
7290   PRINT#win1\"Press any key to continue... "
7300   z$ = INKEY$(#win1,-1)
7310   PRINT#win1: PRINT#win1
7320 END DEFine key_pause
7330 :
10000 DEF PROCedure sa
10010 copy_o ram2_filterINTER_BAS to win2_devel_filterINTER_BAS
10020 END DEFine sa
